# List or Create User Quests POST /api/v1/quests/my-quests/ Content-Type: application/json Lists all quests associated with the authenticated user or creates a new user quest. Reference: https://docs.aisquare.studio/api-reference/ai-square-studio-api/quests/my-quests-list ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: AISquare Studio API version: 1.0.0 paths: /api/v1/quests/my-quests/: post: operationId: my-quests-create summary: List or Create User Quests description: >- Lists all quests associated with the authenticated user or creates a new user quest. tags: - subpackage_quests responses: '200': description: List of user quests content: application/json: schema: $ref: '#/components/schemas/IAMUserQuest' '400': description: Invalid input content: application/json: schema: description: Any type '401': description: Unauthorized content: application/json: schema: description: Any type requestBody: content: application/json: schema: $ref: '#/components/schemas/IAMUserQuest' components: schemas: MinimalIAMUserDetail: type: object properties: profile_picture: type: - string - 'null' format: uri bio: type: - string - 'null' country: type: - string - 'null' phone: type: - string - 'null' linkedin_url: type: - string - 'null' format: uri github_url: type: - string - 'null' format: uri twitter_url: type: - string - 'null' format: uri website_url: type: - string - 'null' format: uri top_domain_elo: type: number format: double top_domain_rank: type: integer required: - profile_picture - bio - country - phone - linkedin_url - github_url - twitter_url - website_url - top_domain_elo - top_domain_rank title: MinimalIAMUserDetail MinimalIAMUser: type: object properties: id: type: integer username: type: string description: >- Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only. email: type: string format: email full_name: type: string is_verified: type: boolean details: type: array items: $ref: '#/components/schemas/MinimalIAMUserDetail' followers_count: type: integer required: - id - username - email - full_name - is_verified - details - followers_count title: MinimalIAMUser MinimalPlayerLevel: type: object properties: id: type: integer uid: type: string format: uuid name: type: string description: type: - string - 'null' avg_score: type: integer required: - id - uid - name description: Minimal serializer for PlayerLevel to be used in other modules title: MinimalPlayerLevel MinimalQuest: type: object properties: id: type: integer uid: type: string format: uuid name: type: string summary: type: - string - 'null' logo: type: - string - 'null' format: uri cover: type: - string - 'null' format: uri player_level: $ref: '#/components/schemas/MinimalPlayerLevel' created_by: $ref: '#/components/schemas/MinimalIAMUser' co_creators: type: array items: $ref: '#/components/schemas/MinimalIAMUser' user_added_quest: type: boolean description: Check if the current user has added this quest workspace_id: type: integer required: - id - uid - name - player_level - created_by - co_creators - user_added_quest - workspace_id description: Mixin to add user_added_quest field to quest serializers title: MinimalQuest GlobalCreationStatusEnum: type: string enum: - not_started - in_progress - completed - failed description: |- * `not_started` - Not Started * `in_progress` - In Progress * `completed` - Completed * `failed` - Failed title: GlobalCreationStatusEnum IAMUserQuest: type: object properties: id: type: integer uid: type: string format: uuid user: $ref: '#/components/schemas/MinimalIAMUser' quest: type: integer quest_details: $ref: '#/components/schemas/MinimalQuest' created_at: type: string format: date-time updated_at: type: string format: date-time progress_percent: type: number format: double progress: description: Any type score: type: number format: double status: $ref: '#/components/schemas/GlobalCreationStatusEnum' completion_date: type: - string - 'null' format: date-time certification_available: type: boolean required: - id - uid - user - quest - quest_details - created_at - updated_at title: IAMUserQuest ``` ## SDK Code Examples ```python import requests url = "https://api.example.com/api/v1/quests/my-quests/" payload = { "quest": 42 } headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/quests/my-quests/'; const options = { method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{"quest":42}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/quests/my-quests/" payload := strings.NewReader("{\n \"quest\": 42\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/quests/my-quests/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{\n \"quest\": 42\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.example.com/api/v1/quests/my-quests/") .header("Content-Type", "application/json") .body("{\n \"quest\": 42\n}") .asString(); ``` ```php request('POST', 'https://api.example.com/api/v1/quests/my-quests/', [ 'body' => '{ "quest": 42 }', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/quests/my-quests/"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"quest\": 42\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = ["quest": 42] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/quests/my-quests/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ```python import requests url = "https://api.example.com/api/v1/quests/my-quests/" payload = { "quest": 42 } headers = {"Content-Type": "application/json"} response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.example.com/api/v1/quests/my-quests/'; const options = { method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{"quest":42}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.example.com/api/v1/quests/my-quests/" payload := strings.NewReader("{\n \"quest\": 42\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.example.com/api/v1/quests/my-quests/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Content-Type"] = 'application/json' request.body = "{\n \"quest\": 42\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.example.com/api/v1/quests/my-quests/") .header("Content-Type", "application/json") .body("{\n \"quest\": 42\n}") .asString(); ``` ```php request('POST', 'https://api.example.com/api/v1/quests/my-quests/', [ 'body' => '{ "quest": 42 }', 'headers' => [ 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.example.com/api/v1/quests/my-quests/"); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"quest\": 42\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Content-Type": "application/json"] let parameters = ["quest": 42] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/api/v1/quests/my-quests/")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```